/* hestonvanilla.C computes vanilla call option price with Heston's Modell 
   for stochastic volatility
   Copyright (C) 2001 Gunter Winkler (guwi17@gmx.de)

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <iostream>
#include <cmath>
#include <complex>

#include "hestonanalytic.h"

using std::cout;
using std::endl;

int main()
{
	heston_complex z = heston_complex(0,1);
	MARKETDATA	market;
	DOUBLE	spot,strike,v,t;

// 	market.rd     = log(1.052); 
// 	market.rf     = log(1.048); 	/* (logarithmic) domestic/foreign interest rates */
// 	market.rho    = -0.1; 
// 	market.kappa  = 2.5; 
// 	market.theta  = 0.06; 
// 	market.xi     = 0.5;	/* stochastic volatility parameters */
// 	market.lambda = 0.0; 	/* price of volatility risk */
	
// 	market.rd     = log(1.05); 
// 	market.rf     = log(1.03); 	/* (logarithmic) domestic/foreign interest rates */
// 	market.rho    = 0.1; 
// 	market.kappa  = 2; 
// 	market.theta  = 0.0025; 
// 	market.xi     = 0.1;	/* stochastic volatility parameters */
// 	market.lambda = 0.0; 	/* price of volatility risk */

// 	spot = 1.03 ;
// 	v = 0.012769;
// 	t = 0.5;

	std::cin >> market.rd;
	std::cin >> market.rf;
	std::cin >> market.rho;
	std::cin >> market.kappa;
	std::cin >> market.theta;
	std::cin >> market.xi;
	std::cin >> market.lambda;

	std::cin >> spot;
	std::cin >> strike;
	std::cin >> v;
	std::cin >> t;

// 	spot   = 1.00 ;
// 	strike = 1.00 ;
// 	v = 0.05225;
// 	t = 0.25;

	std::cout.precision(10);
// 	std::cout         << market.rd;
// 	std::cout << ", " << market.rf;
// 	std::cout << ", " << market.rho;
// 	std::cout << ", " << market.kappa;
// 	std::cout << ", " << market.theta;
// 	std::cout << ", " << market.xi;
// 	std::cout << ", " << market.lambda;
// 
// 	std::cout << ", " << spot;
// 	std::cout << ", " << strike;
// 	std::cout << ", " << v;
// 	std::cout << ", " << t;
// 	std::cout << endl;
//	std::cout << "call: ";
	std::cout << Heston_Call(spot, v, t, strike, market) << endl;

	return 0;
};
