/* fastrand.h - header file for normal distribution */
/*
	Copyright 2001 Gunter Winkler
*/

#ifndef __INC__fastrand__
#define __INC__fastrand__ 1

#include <cmath>
#include "mt19937.h"

/* define the names of the pseudo-random number generator */
#define _FR_RANDOM	genrand(handle)
#define _FR_SRANDOM(h,x) sgenrand(h,x)
#define _FR_FREERANDOM(h)	freegenrand(h)

void sgennormal(PMTDATA& handle, unsigned long seed);
/*
	initialize generator with any nonzero integer
*/

void freegennormal(PMTDATA& handle);
/*
	free handle for gennormal
*/

void gennormal(PMTDATA handle, double & y1, double & y2);
/*  
	returns 2 independet normal distributed values
    with mean 0 and variance 1.
 */
void gencorrnormal(PMTDATA handle, double & y1, double & y2, 
		const double rho, const double sqrtrho );
/*  returns 2 correlated normal distributed values
    with mean 0 and variance 1.
	parameters: rho ....... correlation
	            sqrtrho ... must be sqrt(1 - rho^2)
 */

void gencorrnormal(PMTDATA handle, double & y1, double & y2, 
		const double rho );
/* overloaded function that provides sqrt(1-rho^2) */
/* for fast programs use version above             */

#endif
