/* common types for option valuation */
/*
	Copyright 2001 Gunter Winkler
*/

#ifndef __INC__otypes__
#define __INC__otypes__ 1

/*
 *	types
 */

#define DOUBLE	double

struct MARKETDATA 
{
	DOUBLE	rd, rf; 	/* (logarithmic) domestic/foreign interest rates */
	DOUBLE	rho, kappa, theta, xi;	/* stochastic volatility parameters */
	DOUBLE	lambda; 	/* price of volatility risk */
};

struct OPTIONDATA {
	DOUBLE	strike;
	DOUBLE	spot;
	DOUBLE	time;		/* time to maturity */
	DOUBLE	putcall;	/* 1 = call, -1 = put */
};

#endif
